#ifndef KAESTCHEN_H
#define KAESTCHEN_H

#include <spiellabel.h>
#include <seite.h>
#include <vector>

class SpielLabel;
class Seite;
enum class Position;

class Kaestchen
{
    SpielLabel* spielLabel;
    int x, y;
    Seite* seiteOben;
    Seite* seiteRechts;
    Seite* seiteUnten;
    Seite* seiteLinks;
    Kaestchen* obererNachbar;
    Kaestchen* rechterNachbar {nullptr};
    Kaestchen* untererNachbar {nullptr};
    Kaestchen* linkerNachbar;
    bool ausgegraut {false};
    bool vomMenschenGeschlossen {false};
public:
    //(x, y) ist die linke obere Ecke des Kästchens
    Kaestchen(SpielLabel* spielLabel, int x, int y,
              Kaestchen* linkerNachbar, Kaestchen* obererNachbar);
    ~Kaestchen();
    Kaestchen* getNachbar(Position pos) const;
    bool markiereSeite(int x, int y, Position *seitenPosition);
    void markiereSeite(Position pos);
    Seite* getSeite(Position pos) const;
    std::vector<Position> getOffenePositionen() const;
    bool geschlossen() const;
    void zeichneGeschlossen(bool mensch);
    void setzeZurueck(bool mensch);
    void graueAus();
    bool istAusgegraut() const;
    int anzahlMarkierteSeiten() const;
    std::vector<Seite*> getMarkierteSeiten() const;
    char status() const;
    void setzeVomStatus(char status);
    static const int breite {40};
    static const Qt::GlobalColor grau {Qt::GlobalColor::gray};
};

#endif // KAESTCHEN_H
