#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <string>
#include <fstream>
#include <iostream>//TODO

using namespace std;

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow {parent},
    ui {new Ui::MainWindow},
    groesse {Groesse::KLEIN}
{
    ui->setupUi(this);
    spielLabel = new SpielLabel{this};
    resize();
    setCentralWidget(spielLabel);
    fontBold.setBold(true);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::aktualisiereStatusBar(const QString &s)
{
    statusLabel.setText(s);
    ui->statusBar->addWidget(&statusLabel);
}

void MainWindow::zeigeTemporaereStatusNachricht(const QString &s)
{
    ui->statusBar->showMessage(s, 2000);
}

void MainWindow::on_actionNeues_Spiel_triggered()
{
    spielLabel->erzeugeSpielflaeche(groesse, true);
}

void MainWindow::on_actionKlein_triggered()
{
    setzeGroesse(Groesse::KLEIN);
}

void MainWindow::on_actionMittel_triggered()
{
    setzeGroesse(Groesse::MITTEL);
}

void MainWindow::on_actionGross_triggered()
{
    setzeGroesse(Groesse::GROSS);
}

void MainWindow::setzeGroesse(Groesse groesse, bool graueAus, bool erzeugeNeuesSpiel)
{
    QAction* action;
    switch (groesse) {
    case Groesse::KLEIN:
        action = ui->actionKlein; break;
    case Groesse::MITTEL:
        action = ui->actionMittel; break;
    default:
        action = ui->actionGross; break;
    }
    if (!erzeugeNeuesSpiel && action->font().bold()) return;
    for (QAction* a : {ui->actionKlein, ui->actionMittel, ui->actionGross})
        a->setFont(a == action ? fontBold : font);
    this->groesse = groesse;
    spielLabel->erzeugeSpielflaeche(groesse, graueAus);
    resize();
}

void MainWindow::resize()
{
    setFixedSize(spielLabel->breite(), spielLabel->hoehe() + 40);
}

void MainWindow::on_actionLevel5_triggered()
{
    setzeLevel(5);
}

void MainWindow::on_actionLevel4_triggered()
{
    setzeLevel(4);
}

void MainWindow::on_actionLevel3_triggered()
{
    setzeLevel(3);
}

void MainWindow::on_actionLevel2_triggered()
{
    setzeLevel(2);
}

void MainWindow::on_actionLevel1_triggered()
{
    setzeLevel(1);
}

void MainWindow::setzeLevel(int level)
{
    QAction* action;
    switch (level) {
    case 5:
        action = ui->actionLevel5; break;
    case 4:
        action = ui->actionLevel4; break;
    case 3:
        action = ui->actionLevel3; break;
    case 2:
        action = ui->actionLevel2; break;
    default:
        action = ui->actionLevel1; break;
    }
    for (QAction* a : {ui->actionLevel5, ui->actionLevel4, ui->actionLevel3,
         ui->actionLevel2, ui->actionLevel1})
        a->setFont(a == action ? fontBold : font);
    spielLabel->setzeLevel(level);
}

void MainWindow::on_actionRueckgaengig_triggered()
{
    spielLabel->rueckgaengig();
}

void MainWindow::on_actionWiederherstellen_triggered()
{
    spielLabel->wiederherstellen();
}

void MainWindow::erlaubeRueckgaengig(bool wert)
{
    ui->actionRueckgaengig->setEnabled(wert);
}

void MainWindow::erlaubeWiederherstellen(bool wert)
{
    ui->actionWiederherstellen->setEnabled(wert);
}

void MainWindow::on_actionSpiel_oeffnen_triggered()
{
    spielLabel->oeffnen();
}

void MainWindow::on_actionSpiel_speichern_triggered()
{
    spielLabel->speichern(groesse, false);
}

void MainWindow::on_actionSpiel_speichern_unter_triggered()
{
    spielLabel->speichern(groesse, true);
}

void MainWindow::on_actionMensch_startet_toggled(bool menschStarted)
{
    spielLabel->setzeMenschStarted(menschStarted);
}
