#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <spiellabel.h>
#include <QLabel>

class SpielLabel;
enum class Groesse;

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *mainwindow = 0);
    ~MainWindow();
    void aktualisiereStatusBar(const QString& s);
    void zeigeTemporaereStatusNachricht(const QString& s);
    void erlaubeRueckgaengig(bool wert);
    void erlaubeWiederherstellen(bool wert);
    void setzeGroesse(Groesse groesse, bool graueAus = true,
                      bool erzeugeNeuesSpiel = false);
    void setzeLevel(int level);

private slots:
    void on_actionNeues_Spiel_triggered();
    void on_actionKlein_triggered();
    void on_actionMittel_triggered();
    void on_actionGross_triggered();
    void on_actionLevel5_triggered();
    void on_actionLevel4_triggered();
    void on_actionLevel3_triggered();
    void on_actionLevel2_triggered();
    void on_actionLevel1_triggered();
    void on_actionRueckgaengig_triggered();
    void on_actionWiederherstellen_triggered();
    void on_actionSpiel_oeffnen_triggered();
    void on_actionSpiel_speichern_triggered();
    void on_actionSpiel_speichern_unter_triggered();
    void on_actionMensch_startet_toggled(bool menschStarted);

private:
    Ui::MainWindow *ui;
    SpielLabel* spielLabel;
    QLabel statusLabel;
    QFont font;
    QFont fontBold;
    Groesse groesse;
    void resize();
};

#endif // MAINWINDOW_H
