#include "seite.h"
#include <spiellabel.h>
#include <QPainter>
#include <iostream>//TODO

using namespace std;

Seite::Seite(SpielLabel *spielLabel, int x, int y, Position pos):
    spielLabel {spielLabel}, x {x}, y {y}, pos {pos}
{
    zeichneLinie(farbe);
}

void Seite::setzeGeteilt()
{
    zeichneLinie(schwacheFarbe);
    farbe = schwacheFarbe;
    klickbar = true;
}

bool Seite::setzeMarkiert()
{
    if (!klickbar) return false;
    zeichneLinie(starkeFarbe, dickeBreite);
    dicke = dickeBreite;
    farbe = starkeFarbe;
    klickbar = false;
    markiert = true;
    return true;
}

void Seite::zeichneLinie(Qt::GlobalColor farbe, int breite)
{
    QPainter painter {spielLabel->getSpielflaeche()};
    QPen pen {farbe};
    pen.setWidth(breite);
    painter.setPen(pen);
    painter.drawLine(x
                     + (pos == Position::RECHTS ? Kaestchen::breite : 0),

                     y
                     + (pos == Position::RECHTS && farbe == schwacheFarbe ? 1 : 0)
                     + (pos == Position::UNTEN ? Kaestchen::breite : 0),

                     x
                     + (pos == Position::LINKS ? 0 : Kaestchen::breite),

                     y
                     - (pos == Position::RECHTS && farbe == schwacheFarbe ? 1 : 0)
                     + (pos == Position::OBEN ? 0 : Kaestchen::breite));
    spielLabel->zeichne();
}

void Seite::blinke(bool warnung)
{
    zeichneLinie(warnung ? Qt::GlobalColor::red: Qt::GlobalColor::cyan, dicke);
}

void Seite::setzeNormal()
{
    zeichneLinie(farbe, dicke);
}

void Seite::setzeZurueck()
{
    klickbar = true;
    markiert = false;
    zeichneLinie(SpielLabel::hintergrundfarbe, dicke);
    farbe = schwacheFarbe;
    dicke = duenneBreite;
    setzeNormal();
    for (Seite* nachbar: nachbarn)
        nachbar->setzeNormal();
    //TODO
}

void Seite::setzeNichtKlickbar()
{
    klickbar = false;
    farbe = Kaestchen::grau;
}

bool Seite::istKlickbar() const
{
    return klickbar;
}

bool Seite::istMarkiert() const
{
    return markiert;
}

Position Seite::getPosition() const
{
    return pos;
}

static bool enthaelt(vector<Seite*>& v, Seite* kaestchen)
{
    return find(v.begin(), v.end(), kaestchen) != v.end();
}

void Seite::addNachbar(Seite *nachbar)
{
    if (!enthaelt(nachbarn, nachbar))
        nachbarn.push_back(nachbar);
    if (!enthaelt(nachbar->nachbarn, this))
        nachbar->addNachbar(this);
}
