#ifndef SEITE_H
#define SEITE_H

#include <spiellabel.h>
#include <qnamespace.h>
#include <vector>

class SpielLabel;

enum class Position {OBEN, RECHTS, UNTEN, LINKS};

class Seite
{
    SpielLabel* spielLabel;
    int x;
    int y;
    Position pos;
    bool klickbar {false};
    bool markiert {false};
    static const int duenneBreite {1};
    static const int dickeBreite {2};
    int dicke {duenneBreite};
    static const Qt::GlobalColor schwacheFarbe {Qt::GlobalColor::lightGray};
    static const Qt::GlobalColor starkeFarbe {Qt::GlobalColor::black};
    Qt::GlobalColor farbe {starkeFarbe};
    void zeichneLinie(Qt::GlobalColor farbe, int breite = duenneBreite);
    std::vector<Seite*> nachbarn;
public:
    //(x, y) ist die linke obere Ecke des Kästchens
    Seite(SpielLabel* spielLabel, int x, int y, Position pos);
    //die Seite wird mit einem anderen Kästchen geteilt
    void setzeGeteilt();
    bool setzeMarkiert();
    void blinke(bool warnung);
    void setzeNormal();
    void setzeZurueck();
    void setzeNichtKlickbar();
    bool istKlickbar() const;
    bool istMarkiert() const;
    Position getPosition() const;
    void addNachbar(Seite* nachbar);
};

#endif // SEITE_H
